using System;
using System.Text;
using System.Collections;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using NppScripts;
/*
 '//npp_toolbar_image Shell32.dll|3' associates the script with the 16x16 icon #3 from Shell32.dll and places it on the toolbar
 '//npp_shortcut Ctrl+Alt+Shift+F12' associates the script with the shortcut Ctrl+Alt+Shift+F12
*/
//SoldierEPilot, 2015
//For non-commercial use only

public class Script : NppScript
{
	
	static public string GetSelectedText()
	{
		int start = (int)Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELECTIONSTART, 0, 0);
		int end = (int)Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELECTIONEND, 0, 0);
		var text = new StringBuilder(end - start + 1);
		Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_GETSELTEXT, 0, text);
		return text.ToString();
	}
	
	
    static public void ReplaceSelection(string text)
	{
		Win32.SendMessage(Npp.CurrentScintilla, SciMsg.SCI_REPLACESEL, 0, text);
	}
		

	static public void Brackets()
	{
		string str=GetSelectedText();
		str=str.Replace(@"""", "");
		str=str.Replace(@"{", "");
		str=str.Replace(@"}", "");
		str=str.Replace(" ", "");
		string rs = @"\b\w+\b";
		MatchCollection MC=Regex.Matches(str,rs); 
	    foreach (Match m in MC)
		{
			if (m.Value!="private")
			{
				string rs2=@"\b" + m.Value + @"\b";
				Regex rex=new Regex (rs2);
				str=rex.Replace(str,(@"{" + m.Value + @"}")); 
			}	

		}
		ReplaceSelection(str);
    }
	
	
	public override void Run()
	{
		Brackets();
	}
}